//
// Global Variables for BTERM
//

#include "ansibx.h"
#include "kcomm.h"
#include <dos.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>

extern unsigned char speedb,parityb,stopb,datab;	// Globals for coms setup
extern char SNDFLG,btermquit,lecho,lnfeed,printerf;	// Global flags

extern char *comstatm[];
extern char *comportm[];
extern char *speedm[];
extern char *paritym[];
extern char *stopm[];
extern char *datam[];
extern char *comeditm[];
extern char *exitbterm[];
extern char *hangupm[];
extern char *lnfdm[];
extern char *lechom[];
extern char *prntm[];
extern char *hangmodem[];
extern char *instm[];
extern char *pawse[];
extern char *confbterm[];
extern char *btcsm[];
extern char *wdem[];
extern char *fdem[];
extern char *pdm[];
extern char *attmenm[];
extern char *allcolm[];
extern char *bckcolm[];
extern char *whichcm[];
extern char *onoffm[];
extern char *bcwinm[];
extern char *obdwnm[];
extern char *dialdir[];
extern char *editdir[];

extern unsigned char allattributes[16];
extern unsigned char attributes[8];

// Define Macro to drive printer

#define prnchar(char) putc((char),stdprn)

// Define modem control strings

extern char modemcontrolstring[30];
extern char dialstring[8];
extern char hangupstring[8];
extern char autoanswer[8];
extern char numbertodial[15];
extern char dialtime;
extern char redial;

// Define dial directory arrays

extern char dialname[20];
extern char dialnumber[15];
extern unsigned char dialspeed;
extern unsigned char dialdata;
extern unsigned char dialstop;
extern unsigned char dialparity;
extern char *listing[];

// Define Desktop attrs

extern unsigned char INFWIN,INFBDR,INFTXT,MENWIN,MENBDR,PDNWIN;
extern unsigned char PDNBDR,FLGWIN,FLGBDR,SELCUR,SCRCOL;

// Define routines from OPTIONS.C

void configcoms();
void makeall();
void hangup();
void exit_bterm();
void line_feed();
void local_echo();
void print_sw();
void init_bterm();
void which_menu(unsigned char);
void atxy (char,char);

// Define routines from t42displ

void titleblock();
extern char *input_str(unsigned char,unsigned char,unsigned char,unsigned char);
void dialdiredit(int);
void dialanumber(int);
void clearanumber(int);

// Define routines from KCOMM.C

void send_st (char *);
