// All Control menu's and options are contained here (OPTIONS.C)
// Call from main loop

#include "globals.h"

// Update Colours (for Windows)

void update_colours()
{
	ansibox[0].att=INFWIN;
	ansibox[0].bdr=INFBDR;

	ansibox[1].att=MENWIN;
	ansibox[1].bdr=MENBDR;

	ansibox[2].att=PDNWIN;
	ansibox[2].bdr=PDNBDR;
	ansibox[3].att=PDNWIN;
	ansibox[3].bdr=PDNBDR;
	ansibox[4].att=PDNWIN;
	ansibox[4].bdr=PDNBDR;
	ansibox[5].att=PDNWIN;
	ansibox[5].bdr=PDNBDR;
	ansibox[6].att=PDNWIN;
	ansibox[6].bdr=PDNBDR;

	ansibox[7].att=FLGWIN;
	ansibox[7].bdr=FLGBDR;
	ansibox[8].att=FLGWIN;
	ansibox[8].bdr=FLGBDR;
	ansibox[9].att=FLGWIN;
	ansibox[9].bdr=FLGBDR;
	ansibox[10].att=FLGWIN;
	ansibox[10].bdr=FLGBDR;
	ansibox[11].att=FLGWIN;
	ansibox[11].bdr=FLGBDR;

	ansibox[12].att=INFWIN;
	ansibox[12].bdr=INFBDR;
	ansibox[13].att=INFWIN;
	ansibox[13].bdr=INFBDR;
	ansibox[14].att=INFWIN;
	ansibox[14].bdr=INFBDR;

	ansibox[15].att=MENWIN;
	ansibox[15].bdr=MENBDR;

	ansibox[16].att=INFWIN;
	ansibox[16].bdr=INFBDR;

	ansibox[17].att=MENWIN;
	ansibox[17].bdr=MENBDR;

	ansibox[18].att=INFWIN;
	ansibox[18].bdr=INFBDR;
	ansibox[19].att=FLGWIN;
	ansibox[19].bdr=FLGBDR;
	ansibox[20].att=MENWIN;
	ansibox[20].bdr=MENBDR;
	ansibox[21].att=PDNWIN;
	ansibox[21].bdr=PDNBDR;

	ansibox[22].att=PDNWIN;
	ansibox[22].bdr=PDNBDR;
	ansibox[23].att=PDNWIN;
	ansibox[23].bdr=PDNBDR;
	ansibox[24].att=PDNWIN;
	ansibox[24].bdr=PDNBDR;
	ansibox[25].att=PDNWIN;
	ansibox[25].bdr=PDNBDR;
	ansibox[26].att=PDNWIN;
	ansibox[26].bdr=PDNBDR;
	ansibox[27].att=PDNWIN;
	ansibox[27].bdr=PDNBDR;
	ansibox[28].att=PDNWIN;
	ansibox[28].bdr=PDNBDR;
	ansibox[29].att=MENWIN;
	ansibox[29].bdr=MENBDR;
	ansibox[30].att=INFWIN;
	ansibox[30].bdr=INFBDR;
}

// Atxy - Positions the text cursor

void atxy (x,y)
char x,y;
{
	union REGS r;

	r.h.ah = 2;
	r.h.bh = 0;
	r.h.dh = y;
	r.h.dl = x;

	int86 (0x10, &r, &r);
}

// Sound effects in program - Alarm and bleep

void alarm()
{
	int i;

	if (SNDFLG){

		for (i=0; i<5; i++){
			sound (500);
			delay (50);
			sound (700);
			delay (50);
			}
			nosound();
		}

}

void bleep()
{
	int i;

	if (SNDFLG){
		for (i=440; i<1040; i+=8){
		sound (i);
		delay (1);
		}
		nosound();
	}
}


// Define all windows

void makeall()
{
	make (0,"COM STATUS",25,5,16,1,INFWIN,INFBDR,comstatm,16);
	make (1,"",39,5,6,1,MENWIN,MENBDR,comeditm,6);
	make (2,"",48,6,4,1,PDNWIN,PDNBDR,comportm,4);
	make (3,"",48,7,5,1,PDNWIN,PDNBDR,speedm,5);
	make (4,"",48,8,3,1,PDNWIN,PDNBDR,paritym,3);
	make (5,"",48,9,2,1,PDNWIN,PDNBDR,stopm,2);
	make (6,"",48,10,2,1,PDNWIN,PDNBDR,datam,2);
	make (7,"EXIT BTERM ?",33,10,2,1,FLGWIN,FLGBDR,exitbterm,2);
	make (8,"HANG UP MODEM?",32,10,2,1,FLGWIN,FLGBDR,hangupm,2);
	make (9,"LOCAL ECHO ?",33,10,2,1,FLGWIN,FLGBDR,lechom,2);
	make (10,"LINE FEED?",34,10,2,1,FLGWIN,FLGBDR,lnfdm,2);
	make (11,"PRINTER?",35,10,2,1,FLGWIN,FLGBDR,prntm,2);
	make (12,"",34,11,1,1,INFWIN,INFBDR,hangmodem,1);
	make (13," BTERM (C)1993 K.Phillips T42 Software ",19,0,23,0,INFWIN,INFBDR,instm,23);
	make (14,"",36,11,1,1,INFWIN,INFBDR,pawse,1);
	make (15,"CONFIGURE BTERM MENU",29,9,4,0,MENWIN,MENBDR,confbterm,4);
	make (16,"BTERM COLOUR & SOUND STATUS",30,1,11,1,INFWIN,INFBDR,btcsm,11);
	make (17,"",1,1,7,1,MENWIN,MENBDR,attmenm,7);
	make (18,"WINDOW",41,5,2,0,INFWIN,INFBDR,wdem,2);
	make (19,"FLAG",51,5,1,0,FLGWIN,FLGBDR,fdem,1);
	make (20,"MENU",41,10,1,0,MENWIN,MENBDR,fdem,1);
	make (21,"PULLDOWN",48,10,1,0,PDNWIN,PDNBDR,pdm,1);
	make (22,"",21,6,16,1,PDNWIN,PDNBDR,allcolm,16);
	make (23,"",21,6,8,1,PDNWIN,PDNBDR,bckcolm,8);
	make (24,"",14,5,3,1,PDNWIN,PDNBDR,whichcm,3);
	make (25,"",15,7,2,1,PDNWIN,PDNBDR,onoffm,2);
	make (26,"",8,3,2,1,PDNWIN,PDNBDR,bcwinm,2);
	make (27,"",8,3,3,1,PDNWIN,PDNBDR,obdwnm,3);
	make (28,"",13,0,99,1,PDNWIN,PDNBDR,listing,20);
	make (29,"",36,5,3,1,MENWIN,MENBDR,dialdir,3);
	make (30,"Dial Data",0,0,19,1,INFWIN,INFBDR,editdir,19);
}

// Define default options

void defaulterm()
{
	myport = 1;		// Default COM port setup
	speedb = BPS2400;
	parityb = PARN;
	stopb = STP1;
	datab = DATA8;
	lnfeed = TRUE;
	lecho = FALSE;
	printerf = FALSE;

	SNDFLG = TRUE;		// Set sound on/off flag

	INFWIN = LGYBLK;	// Default Desktop colours
	INFBDR = LGYWHT;
	INFTXT = LGYWHT;
	MENWIN = GRNWHT;
	MENBDR = GRNBLK;
	PDNWIN = REDWHT;
	PDNBDR = REDDGY;
	FLGWIN = REDWHT;
	FLGBDR = BLUYEL;
	SELCUR = BLKWHT + blinking;

	sprintf(modemcontrolstring,"AT Z*AT S0=45 V1 X1*");	// Set up modem control
	sprintf(dialstring,"AT DT ");
	sprintf(hangupstring,"AT H0*");
	sprintf(autoanswer,"AT A*");

	dialtime = 45;
	redial = TRUE;
}

// Save Configuration file

void save_cfg()
{
	char fbuf[100];	// Buffer to store all config data
	int handle,i;

	fbuf[0]=myport;	// Store COM port data in file buffer - fbuf[];
	fbuf[1]=speedb;
	fbuf[2]=parityb;
	fbuf[3]=stopb;
	fbuf[4]=datab;
	fbuf[5]=lecho;
	fbuf[6]=lnfeed;
	fbuf[7]=printerf;

	fbuf[8]=INFWIN;	// Default Desktop colours
	fbuf[9]=INFBDR;
	fbuf[10]=INFTXT;
	fbuf[11]=MENWIN;
	fbuf[12]=MENBDR;
	fbuf[13]=PDNWIN;
	fbuf[14]=PDNBDR;
	fbuf[15]=FLGWIN;
	fbuf[16]=FLGBDR;
	fbuf[17]=SELCUR;
	fbuf[18]=SCRCOL;
	fbuf[19]=SNDFLG;

	for (i=0; i<30;i++)			// Insert strings
		fbuf[20+i]=modemcontrolstring[i];
	for (i=0; i<8; i++){
		fbuf[50+i]=dialstring[i];
		fbuf[58+i]=hangupstring[i];
		fbuf[66+i]=autoanswer[i];
		}

	fbuf[74]=dialtime;
	fbuf[75]=redial;

	handle = open ("BTERM.CFG", (O_BINARY | O_DENYNONE | O_RDWR | O_CREAT));

	if (handle != -1){		// Check for any errors
		write (handle, fbuf, 100);// Then write it
		close (handle);		// Close the file
		}
	else {
		close (handle);
		cls(BLKWHT);
		printf ("File Write error occured");
		exit(0);
		}
}

// Save dialling directory

void save_dial()
{
	int i,j;
	FILE *dialfile;

	if (NULL != (dialfile=fopen("BTERM.FON","w")))
		{

		// Then insert it into listing

		for (i=0; i<100; i++)
			for (j=0;j<50;j++)
				putc(listing[i][j],dialfile);

		fclose(dialfile);

		}

	else
		alarm();			// Else, No file.

}

// Load dialling directory

void load_dial()
{
	int i,j;
	FILE *dialfile;

	if (NULL != (dialfile=fopen("BTERM.FON","r")))
		{

		// Then insert it into listing

		for (i=0; i<100; i++)
			for (j=0;j<50;j++)
				listing[i][j]=getc(dialfile);

		fclose(dialfile);

		}

	else
		alarm();			// Else, No file.

}

// Save The screen image as ASCII (No Attributes)

void save_image()
{
	char fbuf[2000];	// Buffer to store Screen
	int i,j,k,handle;
	char far *scrn;

	k=0;

	for (i=0; i<=24; i++)
		for (j=0; j<=79; j++){
			scrn = vidmem + (j*2) + (i*160);
			fbuf[k++] = *scrn;
			}

	handle = open ("IMAGE.TXT", (O_BINARY | O_APPEND | O_RDWR | O_DENYNONE | O_CREAT));

	// 'handle' will add another file onto the end of the existing one
	// using O_APPEND to add onto the end of the file.

	if (handle != -1){			// Check if it exists
		write (handle, fbuf,2000);	// Then write it
		close (handle);			// Close the file
		}
	else {
		close (handle);
		cls(BLKWHT);
		printf ("File Write error occured");
		exit(0);
		}
}

// COMS port configuration routines

void updateconfw()
{
	open_box (0);

	switch (myport){
		case 0:	wstring (29,8,INFTXT,"COM1");
			break;
		case 1:	wstring (29,8,INFTXT,"COM2");
			break;
		case 2:	wstring (29,8,INFTXT,"COM3");
			break;
		case 3:	wstring (29,8,INFTXT,"COM4");
			break;
		default: break;
		}

	switch (speedb){
		case BPS0300:	wstring (29,11,INFTXT,"0300");
				break;
		case BPS1200:	wstring (29,11,INFTXT,"1200");
				break;
		case BPS2400:	wstring (29,11,INFTXT,"2400");
				break;
		case BPS4800:	wstring (29,11,INFTXT,"4800");
				break;
		case BPS9600:	wstring (29,11,INFTXT,"9600");
				break;
		default:	break;
		}

	switch (parityb){
		case PARN:	wstring (29,14,INFTXT,"NONE");
				break;
		case PARE:	wstring (29,14,INFTXT,"EVEN");
				break;
		case PARO:	wstring (29,14,INFTXT,"ODD");
				break;
		default: break;
		}

	switch (stopb){
		case STP1:	wstring (29,17,INFTXT,"1BIT");
				break;
		case STP2:	wstring (29,17,INFTXT,"2BIT");
				break;
		default: break;
		}

	switch (datab){
		case DATA7:	wstring (29,20,INFTXT,"7BIT");
				break;
		case DATA8:	wstring (29,20,INFTXT,"8BIT");
				break;
		default: break;
		}
}

void configcoms()
{
	int No_set,quit,item,item2;

	quit = TRUE;
	No_set = FALSE;

	updateconfw();
	open_box (1);

	while (quit){

	item = select(1,SELCUR);
	switch(item){
		case 0:	open_box(2);
			item2 = select(2,SELCUR);
			switch(item2){
				case -1 : break;
				case 0:	wstring (29,8,INFTXT,"COM1");
					myport = item2;
					break;
				case 1:	wstring (29,8,INFTXT,"COM2");
					myport = item2;
					break;
				case 2:	wstring (29,8,INFTXT,"COM3");
					myport = item2;
					break;
				case 3:	wstring (29,8,INFTXT,"COM4");
					myport = item2;
					break;
				default: break;
			       }
			close_box(2);
			break;

		case 1:	open_box(3);
			item2 = select(3,SELCUR);
			switch(item2){
				case -1 : break;
				case 0:	wstring (29,11,INFTXT,"0300");
					speedb = BPS0300;
					break;
				case 1:	wstring (29,11,INFTXT,"1200");
					speedb = BPS1200;
					break;
				case 2:	wstring (29,11,INFTXT,"2400");
					speedb = BPS2400;
					break;
				case 3:	wstring (29,11,INFTXT,"4800");
					speedb = BPS4800;
					break;
				case 4:	wstring (29,11,INFTXT,"9600");
					speedb = BPS9600;
					break;
				default: break;
			       }
			close_box(3);
			break;

		case 2:	open_box(4);
			item2 = select(4,SELCUR);
			switch(item2){
				case -1 : break;
				case 0:	wstring (29,14,INFTXT,"NONE");
					parityb = PARN;
					break;
				case 1:	wstring (29,14,INFTXT,"EVEN");
					parityb = PARE;
					break;
				case 2:	wstring (29,14,INFTXT,"ODD ");
					parityb = PARO;
					break;
				default: break;
			       }
			close_box(4);
			break;

		case 3:	open_box(5);
			item2 = select(5,SELCUR);
			switch(item2){
				case -1 : break;
				case 0:	wstring (29,17,INFTXT,"1BIT");
					stopb = STP1;
					break;
				case 1:	wstring (29,17,INFTXT,"2BIT");
					stopb = STP2;
					break;
				default: break;
			       }
			close_box(5);
			break;

		case 4:	open_box(6);
			item2 = select(6,SELCUR);
			switch(item2){
				case -1 : break;
				case 0:	wstring (29,20,INFTXT,"7BIT");
					datab = DATA7;
					break;
				case 1:	wstring (29,20,INFTXT,"8BIT");
					datab = DATA8;
					break;
				default: break;
			       }
			close_box(6);
			break;

		case 5 : quit = FALSE;
			break;

		case -1 : quit = FALSE;
			  No_set=TRUE;
			break;

		default : break;

		} // End of switch item

	} // End of WHILE

	close_box (1);
	close_box (0);

	if (No_set == FALSE){
		hangupmodem(500);	// Drop DTR (ie. Hang up)
		ser_close();    // Deactivate Interrupts
		set_com();	// Init new data
		ser_init();	// Init Line
		set_interrupt();	// Reactivate interrupts
	}
}

// Redraw Desktop while editing

void redraw_dt()
{
	draw_box(16);	// Open main box
	draw_box(18);	// Open demo boxes
	draw_box(19);
	draw_box(20);
	draw_box(21);
	draw_box(17);

	wstring (32,3,INFWIN,"COLOURS");
	wstring (41,3,INFWIN,"SOUND:");
	wstring (51,3,SELCUR,"SELECT");
	wstring (43,7,INFTXT,"TEXT");

	wstring (32,5,BLK BAK + BLU,"BLU");
	wstring (32,6,BLK BAK + RED,"RED");
	wstring (32,7,BLK BAK + GRN,"GRN");
	wstring (32,8,BLK BAK + CYN,"CYN");
	wstring (32,9,BLK BAK + BLU + 8,"BBL");
	wstring (32,10,BLK BAK + RED + 8,"BRD");
	wstring (32,11,BLK BAK + GRN + 8,"BGN");
	wstring (32,12,BLK BAK + CYN + 8,"BCN");
	wstring (36,5,LGY BAK + BLK,"BLK");
	wstring (36,6,BLK BAK + MAG,"MAG");
	wstring (36,7,BLK BAK + BRN,"BWN");
	wstring (36,8,BLK BAK + LGY,"LGY");
	wstring (36,9,BLK BAK + BLK + 8,"DGY");
	wstring (36,10,BLK BAK + MAG + 8,"BMG");
	wstring (36,11,BLK BAK + YEL,"YEL");
	wstring (36,12,BLK BAK + WHT,"WHT");

	if (SNDFLG)
		wstring (47,3,INFTXT,"ON ");
	else
		wstring (47,3,INFTXT,"OFF");

}

// Configure Colour & sound

void desktop()
{	int pointer,pt1,pt2,pt3,quit;

	quit = FALSE;

	open_box(16);	// Open main box
	open_box(18);	// Open demo boxes
	open_box(19);
	open_box(20);
	open_box(21);

	wstring (32,3,INFWIN,"COLOURS");
	wstring (41,3,INFWIN,"SOUND:");
	wstring (51,3,SELCUR,"SELECT");
	wstring (43,7,INFTXT,"TEXT");

	wstring (32,5,BLK BAK + BLU,"BLU");
	wstring (32,6,BLK BAK + RED,"RED");
	wstring (32,7,BLK BAK + GRN,"GRN");
	wstring (32,8,BLK BAK + CYN,"CYN");
	wstring (32,9,BLK BAK + BLU + 8,"BBL");
	wstring (32,10,BLK BAK + RED + 8,"BRD");
	wstring (32,11,BLK BAK + GRN + 8,"BGN");
	wstring (32,12,BLK BAK + CYN + 8,"BCN");
	wstring (36,5,LGY BAK + BLK,"BLK");
	wstring (36,6,BLK BAK + MAG,"MAG");
	wstring (36,7,BLK BAK + BRN,"BWN");
	wstring (36,8,BLK BAK + LGY,"LGY");
	wstring (36,9,BLK BAK + BLK + 8,"DGY");
	wstring (36,10,BLK BAK + MAG + 8,"BMG");
	wstring (36,11,BLK BAK + YEL,"YEL");
	wstring (36,12,BLK BAK + WHT,"WHT");

	if (SNDFLG)
		wstring (47,3,INFTXT,"ON ");
	else
		wstring (47,3,INFTXT,"OFF");

	open_box (17);	// Open up main menu

	while (!quit){

	pointer = select (17,SELCUR);
	switch (pointer){
		case -1:quit = TRUE;
			break;

// *** WINDOW SELECTED ***

		case 0:	open_box (27);		// Select window menu
			pt1 = select (27,SELCUR);
			switch (pt1) {		// Open PT1 case
				case -1: break;

				case 0: open_box (24);	// Selected border
					pt2 = select (24,SELCUR);
					switch (pt2){	// Open PT2 case(fore/back/BLINK)
						case -1:break;
						case 0: open_box (22);	// Selected Foreground
							pt3 = select (22,SELCUR);
							if (pt3 != -1){
								INFBDR = (INFBDR & 240);
								INFBDR = (INFBDR | allattributes[pt3]);
								}
							close_box (22);
							break;

						case 1: open_box (23);	// Selected Background
							pt3 = select (23,SELCUR);
							if (pt3 != -1){
								INFBDR = (INFBDR & 143);
								INFBDR = (INFBDR | attributes[pt3]);
								}
							close_box (23);
							break;

						case 2: open_box (25);	// Selected blink
							pt3 = select (25,SELCUR);
							switch (pt3){
								case -1:break;
								case 0:	INFBDR = (INFBDR & 127);
									break;
								case 1:	INFBDR = (INFBDR | 128);
									break;
								}
							close_box (25);
							break;

						default:break;
						}	// Close PT2 case
					close_box(24);
					break;


					case 1: open_box (24);	// Selected Window
						pt2 = select (24,SELCUR);
						switch (pt2){	// Open PT2 case
							case -1:break;
							case 0: open_box (22);	// Selected Foreground
								pt3 = select (22,SELCUR);
								if (pt3 != -1){
									INFWIN = (INFWIN & 240);
									INFWIN = (INFWIN | allattributes[pt3]);
									}
								close_box (22);
								break;

							case 1: open_box (23);	// Selected Background
								pt3 = select (23,SELCUR);
								if (pt3 != -1){
									INFWIN = (INFWIN & 143);
									INFWIN = (INFWIN | attributes[pt3]);
									}
								close_box (23);
								break;

							case 2: open_box (25);	// Selected blink
								pt3 = select (25,SELCUR);
								switch (pt3){
									case -1:break;
									case 0:	INFWIN = (INFWIN & 127);
										break;
									case 1:	INFWIN = (INFWIN | 128);
										break;
									}
									close_box (25);
								break;

							default:break;
							}	// Close PT2 case
						close_box(24);
						break;

					case 2: open_box (24);	// Selected Text
						pt2 = select (24,SELCUR);
						switch (pt2){	// Open PT2 case
							case -1:break;
							case 0: open_box (22);	// Selected Foreground
								pt3 = select (22,SELCUR);
								if (pt3 != -1){
									INFTXT = (INFTXT & 240);
									INFTXT = (INFTXT | allattributes[pt3]);
									}
								close_box (22);
								break;

							case 1: open_box (23);	// Selected Background
								pt3 = select (23,SELCUR);
								if (pt3 != -1){
									INFTXT = (INFTXT & 143);
									INFTXT = (INFTXT | attributes[pt3]);
									}
								close_box (23);
								break;

							case 2: open_box (25);	// Selected blink
								pt3 = select (25,SELCUR);
								switch (pt3){
									case -1:break;
									case 0:	INFTXT = (INFTXT & 127);
										break;
									case 1:	INFTXT = (INFTXT | 128);
										break;
									}
								close_box (25);
								break;

							default:break;
							}	// Close PT2 case (Fore/back/text)
						close_box(24);
						break;

						}	// Close PT1 case (Window Data)
					close_box(27);
					update_colours();
					redraw_dt();
					wstring (43,7,INFTXT,"TEXT");
					break;

// *** MENU SELECTED **

		case 1:	open_box (26);		// Select MENU menu
			pt1 = select (26,SELCUR);
			switch (pt1) {		// Open PT1 case
				case -1: break;

				case 0: open_box (24);	// Selected border
					pt2 = select (24,SELCUR);
					switch (pt2){	// Open PT2 case(fore/back/BLINK)
						case -1:break;
						case 0: open_box (22);	// Selected Foreground
							pt3 = select (22,SELCUR);
							if (pt3 != -1){
								MENBDR = (MENBDR & 240);
								MENBDR = (MENBDR | allattributes[pt3]);
								}
							close_box (22);
							break;

						case 1: open_box (23);	// Selected Background
							pt3 = select (23,SELCUR);
							if (pt3 != -1){
								MENBDR = (MENBDR & 143);
								MENBDR = (MENBDR | attributes[pt3]);
								}
							close_box (23);
							break;

						case 2: open_box (25);	// Selected blink
							pt3 = select (25,SELCUR);
							switch (pt3){
								case -1:break;
								case 0:	MENBDR = (MENBDR & 127);
									break;
								case 1:	MENBDR = (MENBDR | 128);
									break;
								}
							close_box (25);
							break;

						default:break;
						}	// Close PT2 case
					close_box(24);
					break;


					case 1: open_box (24);	// Selected Window
						pt2 = select (24,SELCUR);
						switch (pt2){	// Open PT2 case
							case -1:break;
							case 0: open_box (22);	// Selected Foreground
								pt3 = select (22,SELCUR);
								if (pt3 != -1){
									MENWIN = (MENWIN & 240);
									MENWIN = (MENWIN | allattributes[pt3]);
									}
								close_box (22);
								break;

							case 1: open_box (23);	// Selected Background
								pt3 = select (23,SELCUR);
								if (pt3 != -1){
									MENWIN = (MENWIN & 143);
									MENWIN = (MENWIN | attributes[pt3]);
									}
								close_box (23);
								break;

							case 2: open_box (25);	// Selected blink
								pt3 = select (25,SELCUR);
								switch (pt3){
									case -1:break;
									case 0:	MENWIN = (MENWIN & 127);
										break;
									case 1:	MENWIN = (MENWIN | 128);
										break;
									}
									close_box (25);
								break;

							default:break;
							}	// Close PT2 case
						close_box(24);
						break;

					} // Close PT1 case
				close_box(26);
				update_colours();
				redraw_dt();
				break;


// *** PULLDOWN SELECTED **

		case 2:	open_box (26);		// Select PULLDOWN menu			pt1 = select (26,selcur);
			pt1 = select (26,SELCUR);
			switch (pt1) {		// Open PT1 case
				case -1: break;

				case 0: open_box (24);	// Selected border
					pt2 = select (24,SELCUR);
					switch (pt2){	// Open PT2 case(fore/back/BLINK)
						case -1:break;
						case 0: open_box (22);	// Selected Foreground
							pt3 = select (22,SELCUR);
							if (pt3 != -1){
								PDNBDR = (PDNBDR & 240);
								PDNBDR = (PDNBDR | allattributes[pt3]);
								}
							close_box (22);
							break;

						case 1: open_box (23);	// Selected Background
							pt3 = select (23,SELCUR);
							if (pt3 != -1){
								PDNBDR = (PDNBDR & 143);
								PDNBDR = (PDNBDR | attributes[pt3]);
								}
							close_box (23);
							break;

						case 2: open_box (25);	// Selected blink
							pt3 = select (25,SELCUR);
							switch (pt3){
								case -1:break;
								case 0:	PDNBDR = (PDNBDR & 127);
									break;
								case 1:	PDNBDR = (PDNBDR | 128);
									break;
								}
							close_box (25);
							break;

						default:break;
						}	// Close PT2 case
					close_box(24);
					break;


					case 1: open_box (24);	// Selected Window
						pt2 = select (24,SELCUR);
						switch (pt2){	// Open PT2 case
							case -1:break;
							case 0: open_box (22);	// Selected Foreground
								pt3 = select (22,SELCUR);
								if (pt3 != -1){
									PDNWIN = (PDNWIN & 240);
									PDNWIN = (PDNWIN | allattributes[pt3]);
									}
								close_box (22);
								break;

							case 1: open_box (23);	// Selected Background
								pt3 = select (23,SELCUR);
								if (pt3 != -1){
									PDNWIN = (PDNWIN & 143);
									PDNWIN = (PDNWIN | attributes[pt3]);
									}
								close_box (23);
								break;

							case 2: open_box (25);	// Selected blink
								pt3 = select (25,SELCUR);
								switch (pt3){
									case -1:break;
									case 0:	PDNWIN = (PDNWIN & 127);
										break;
									case 1:	PDNWIN = (PDNWIN | 128);
										break;
									}
									close_box (25);
								break;

							default:break;
							}	// Close PT2 case
						close_box(24);
						break;

					} // Close PT1 case
				close_box (26);
				update_colours();
				redraw_dt();
				break;

// *** FLAG SELECTED **

		case 3:	open_box (26);		// Select FLAG menu
			pt1 = select (26,SELCUR);
			switch (pt1) {		// Open PT1 case
				case -1: break;

				case 0: open_box (24);	// Selected border
					pt2 = select (24,SELCUR);
					switch (pt2){	// Open PT2 case(fore/back/BLINK)
						case -1:break;
						case 0: open_box (22);	// Selected Foreground
							pt3 = select (22,SELCUR);
							if (pt3 != -1){
								FLGBDR = (FLGBDR & 240);
								FLGBDR = (FLGBDR | allattributes[pt3]);
								}
							close_box (22);
							break;

						case 1: open_box (23);	// Selected Background
							pt3 = select (23,SELCUR);
							if (pt3 != -1){
								FLGBDR = (FLGBDR & 143);
								FLGBDR = (FLGBDR | attributes[pt3]);
								}
							close_box (23);
							break;

						case 2: open_box (25);	// Selected blink
							pt3 = select (25,SELCUR);
							switch (pt3){
								case -1:break;
								case 0: FLGBDR = (FLGBDR & 127);
									break;
								case 1:	FLGBDR = (FLGBDR | 128);
									break;
								}
							close_box (25);
							break;

						default:break;
						}	// Close PT2 case
					close_box (24);
					break;


					case 1: open_box (24);	// Selected Window
						pt2 = select (24,SELCUR);
						switch (pt2){	// Open PT2 case
							case -1:break;
							case 0: open_box (22);	// Selected Foreground
								pt3 = select (22,SELCUR);
								if (pt3 != -1){
									FLGWIN = (FLGWIN & 240);
									FLGWIN = (FLGWIN | allattributes[pt3]);
									}
								close_box (22);
								break;

							case 1: open_box (23);	// Selected Background
								pt3 = select (23,SELCUR);
								if (pt3 != -1){
									FLGWIN = (FLGWIN & 143);
									FLGWIN = (FLGWIN | attributes[pt3]);
									}
								close_box (23);
								break;

							case 2: open_box (25);	// Selected blink
								pt3 = select (25,SELCUR);
								switch (pt3){
									case -1:break;
									case 0:	FLGWIN = (FLGWIN & 127);
										break;
									case 1:	FLGWIN = (FLGWIN | 128);
										break;
									}
									close_box (25);
								break;

							default:break;
							}	// Close PT2 case
				close_box (24);
				break;

					} // Close PT1 case
				close_box(26);
				update_colours();
				redraw_dt();
				break;

// *** SELECTOR **

		case 4:	open_box (24);	// Selected border
			pt2 = select (24,SELCUR);
			switch (pt2){	// Open PT2 case(fore/back/BLINK)
				case -1:break;
				case 0: open_box (22);	// Selected Foreground
					pt3 = select (22,SELCUR);
					if (pt3 != -1){
						SELCUR = (SELCUR & 240);
						SELCUR = (SELCUR | allattributes[pt3]);
						}
					close_box (22);
					break;
				case 1: open_box (23);	// Selected Background
					pt3 = select (23,SELCUR);
					if (pt3 != -1){
						SELCUR = (SELCUR & 143);
						SELCUR = (SELCUR | attributes[pt3]);
						}
					close_box (23);
					break;
				case 2: open_box (25);	// Selected blink
					pt3 = select (25,SELCUR);
					switch (pt3){
						case -1:break;
						case 0:	SELCUR = (SELCUR & 127);
							break;
						case 1:	SELCUR = (SELCUR | 128);
							break;
						}
					close_box (25);
					break;
				default:break;
				}	// Close PT2 case
			close_box (24);
			update_colours();
			redraw_dt();
			break;


		case 5:	open_box(25);
			pt2 = select (25,SELCUR);
			if (pt2 != -1)
				SNDFLG = pt2;
			close_box (25);
			update_colours();
			redraw_dt();
			break;

		case 6: update_colours();
			quit = TRUE;
			break;


		} // Close POINTER case
	}

	close_box (17);
	close_box (16);

}

// Exit the program

void exit_bterm()
{
	int xx;

	open_box (7);
	xx = select(7,SELCUR);
	close_box (7);
	if (xx != -1)
		btermquit = xx;
}


// Hang up the modem ?

void hangup()
{
	int yehno;

	open_box (8);
	yehno = select (8,SELCUR);
	close_box (8);
	if (!yehno){
		open_box (12);
		bleep();
		hangupmodem(1000);
		close_box (12);
		}

}

// Line feed on/off

void line_feed()
{
	int xx;

	open_box(10);
	xx = select (10,SELCUR);
	close_box(10);
	if (xx != -1)
		lnfeed = xx;
}

// Local ECHO on/off

void local_echo()
{
	int xx;

	open_box (9);
	xx = select (9,SELCUR);
	close_box (9);
	if (xx != -1)
		lecho = xx;
}

// Printer output on/off

void print_sw()
{
	int xx;

	open_box (11);
	xx = select (11,SELCUR);
	close_box (11);
	if (xx != -1)
		printerf = xx;
}

// Try and load the config file

void load_cfg()
{
	char fbuf[100];	// Buffer to store all config data
	int handle,i,okdata;

	okdata = FALSE;
	handle = open ("BTERM.CFG", (O_BINARY | O_RDONLY));

	if (handle != -1){		// Check if it exists
		okdata = TRUE;
		read (handle, fbuf, 100);	// Then read it
		close (handle);		// Close the file
		}

	if (okdata){
		myport = fbuf[0];	// Load COM port info
		speedb = fbuf[1];
		parityb = fbuf[2];
		stopb = fbuf[3];
		datab = fbuf[4];
		lecho = fbuf[5];
		lnfeed = fbuf[6];
		printerf = fbuf[7];

		INFWIN=fbuf[8];	// Default Desktop colours
		INFBDR=fbuf[9];
		INFTXT=fbuf[10];
		MENWIN=fbuf[11];
		MENBDR=fbuf[12];
		PDNWIN=fbuf[13];
		PDNBDR=fbuf[14];
		FLGWIN=fbuf[15];
		FLGBDR=fbuf[16];
		SELCUR=fbuf[17];
		SCRCOL=fbuf[18];
		SNDFLG=fbuf[19];

		for (i=0; i<30;i++)			// Insert strings
			modemcontrolstring[i]=fbuf[20+i];
		for (i=0; i<8; i++){
			dialstring[i]=fbuf[50+i];
			hangupstring[i]=fbuf[58+i];
			autoanswer[i]=fbuf[66+i];
			}

		dialtime=fbuf[74];
		redial=fbuf[75];

		}
	else
		defaulterm();

}

// Display the ALT+Z box

void displayaltx()
{
	cstring (2,INFWIN,"* * * Terminal Line Control * * *");
	cstring (9,INFWIN,"* * * Miscellaneous Options * * *");
	cstring (15,INFWIN,"* * * Screen Output Control * * *");

	cstring (4,INFTXT,"ALT+H - Hang up the modem");
	cstring (5,INFTXT,"ALT+E - Local Echo on/off");
	cstring (6,INFTXT,"ALT+L - Linefeed on/off");
	cstring (7,INFTXT,"ALT+P - Printer Output on/off");

	cstring (11,INFTXT,"ALT+O - Configure BTERM");
	cstring (12,INFTXT,"ALT+X - Exit BTERM");
	cstring (13,INFTXT,"ALT+D - Dial Directory");

	cstring (17,INFTXT,"ALT+C - Clear The Screen");
	cstring (18,INFTXT,"ALT+I - Save Image To Disk");
	cstring (19,INFTXT,"ALT+S - Pause Screen");

	cstring (22,INFTXT,"ALT+Z - Display This Window");

	while (!kbhit());
	getch();
}

// Initialise bterm hardware

void init_bterm()
{
	btermquit = TRUE;
	buffer = calloc (11,1000);	// Allocate some main memory
	if (buffer == NULL){
		printf("BTERM : Not Enough Memory");	// Exit if none!
		exit (1);
		}

	load_cfg();	// Try and load configuration file
	titleblock();	// Title screen + wait

	SCRCOL = BLKWHT;

	makeall();	// Create all windows

	load_dial();	// Try and load the dialing directory

	set_com();	// Then set up coms 8250 registers
	ser_init();	// Set up line
	set_interrupt();// Set up interrupt

	inptr = outptr = 0;	// Initialise buffer

}

// Control routine (enter with special char code)

void which_menu( unsigned char c)
{
	int xx,xy,quit;

	switch (c){

		case (0x23):	hangup();	// ALT+H = 'hang up'
				break;
		case (0x12):	local_echo();	// ALT+E = 'local echo'
				break;
		case (0x26):	line_feed();	// ALT+L = 'line feed'
				break;
		case (0x2d):	exit_bterm();	// ALT+X = 'Exit Bterm'
				break;
		case (0x19):	print_sw();	// ALT+P = 'Printer'
				break;
		case (0x17):	save_image();	// ALT+I = 'Save image'
				break;
		case (0x1f):    open_box(14);	// ALT+S = 'Pause'
				bleep();
				while (!kbhit());
				getch();
				close_box(14);
				break;
		case (0x2e):	cls (SCRCOL);	// ALT+C = 'Clear screen'
				atxy (0,0);
				break;
		case (0x18):    open_box (15);	// ALT+O = 'Configure BTERM'

				quit=FALSE;

				while (!quit){
				xx = select (15,SELCUR);
				switch (xx){
					case -1:quit=TRUE;
						break;
					case 0:	configcoms();
						break;
					case 1: desktop();
						draw_box(15);
						break;
					case 2:	save_dial();
						bleep();
						quit=TRUE;
						break;
					case 3: save_cfg();
						bleep();
						quit=TRUE;
						break;
					default: break;
					}
				}
				close_box(15);
				break;
		case (0x20):	open_box(28);		// ALT+D = 'Dial directory'
				quit = TRUE;

				while (quit){

					xx = select(28,SELCUR);
					if (xx == -1)
						quit=FALSE;
					else
						{
						open_box(29);		// Select function
						xy=select(29,SELCUR);
						close_box(29);

						switch(xy){
							case -1	:       quit=FALSE;
									break;
							case 0  :    	dialanumber(xx);
									quit=FALSE;
									break;
							case 1	:	dialdiredit(xx);
									draw_box(28);
									break;
							case 2	:      	clearanumber(xx);
									draw_box(28);
									break;
							default	:	break;
							}
						}
				}

				close_box(28);
				break;
		case (0x2c):	open_box(13);	// ALT+Z = 'List command keys'
				displayaltx();
				close_box(13);
				break;
		default:	break;

		}
}
